//
//  UUIDManager.m
//  Pods-Runner
//
//  Created by 武耀琳 on 2023/3/8.
//

#import "UUIDManager.h"
static UUIDManager *_uuidManager = nil;

@interface UUIDManager()


@property NSMutableDictionary<NSString *,NSUUID *> *seqMap;

@end


@implementation UUIDManager


+(instancetype)getInstance{
    if(!_uuidManager){
        @synchronized (self) {
            if(!_uuidManager){
                _uuidManager = [[UUIDManager alloc] init];
                _uuidManager.seqMap = [[NSMutableDictionary alloc] init];
            }
        }
    }
    return _uuidManager;
}

-(void)generateUUID:(NSString *)seq{
    [_seqMap setObject:[NSUUID UUID] forKey:seq];
}


-(NSUUID *)getUUID:(NSString *)seq{
    return [_seqMap objectForKey:seq];
}

@end
